/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;

import java.util.Calendar;

import net.micode.notes.R;
import net.micode.notes.ui.DateTimePicker;
import net.micode.notes.ui.DateTimePicker.OnDateTimeChangedListener;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.text.format.DateFormat;
import android.text.format.DateUtils;

public class DateTimePickerDialog extends AlertDialog implements OnClickListener {

    private Calendar mDate = Calendar.getInstance();//calendar变量便于时间操作
    private boolean mIs24HourView;
    private OnDateTimeSetListener mOnDateTimeSetListener;//监听用户设置时间
    private DateTimePicker mDateTimePicker;//view对象，选择器

    public interface OnDateTimeSetListener {
        void OnDateTimeSet(AlertDialog dialog, long date);
    }

    public DateTimePickerDialog(Context context, long date) {
        super(context);//实例化
        mDateTimePicker = new DateTimePicker(context);
        setView(mDateTimePicker);//添加视图
        mDateTimePicker.setOnDateTimeChangedListener(new OnDateTimeChangedListener() {
            public void onDateTimeChanged(DateTimePicker view, int year, int month,
                    int dayOfMonth, int hourOfDay, int minute) {
                mDate.set(Calendar.YEAR, year);
                mDate.set(Calendar.MONTH, month);
                mDate.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                mDate.set(Calendar.HOUR_OF_DAY, hourOfDay);
                mDate.set(Calendar.MINUTE, minute);//设置当前时间
                updateTitle(mDate.getTimeInMillis());
            }
        });//向选择时间的选择器设置监听时间改变的监听器
        mDate.setTimeInMillis(date);//设置时间毫秒单位
        mDate.set(Calendar.SECOND, 0);//秒数设置为0
        mDateTimePicker.setCurrentDate(mDate.getTimeInMillis());//选择器设置当前时间
        setButton(context.getString(R.string.datetime_dialog_ok), this);//设置按钮
        setButton2(context.getString(R.string.datetime_dialog_cancel), (OnClickListener)null);//设置按钮
        set24HourView(DateFormat.is24HourFormat(this.getContext()));//设置日期是24小时制
        updateTitle(mDate.getTimeInMillis());//更新显示日期
    }

    public void set24HourView(boolean is24HourView) {
        mIs24HourView = is24HourView;
    }

    public void setOnDateTimeSetListener(OnDateTimeSetListener callBack) {
        mOnDateTimeSetListener = callBack;
    }

    //用于格式日期显示
    private void updateTitle(long date) {
        int flag =
            DateUtils.FORMAT_SHOW_YEAR |
            DateUtils.FORMAT_SHOW_DATE |
            DateUtils.FORMAT_SHOW_TIME;
        flag |= mIs24HourView ? DateUtils.FORMAT_24HOUR : DateUtils.FORMAT_24HOUR;//DateUtils类日期格式工具类
        setTitle(DateUtils.formatDateTime(this.getContext(), date, flag));
    }

    //响应用户点击设置按钮
    public void onClick(DialogInterface arg0, int arg1) {
        if (mOnDateTimeSetListener != null) {
            mOnDateTimeSetListener.OnDateTimeSet(this, mDate.getTimeInMillis());
        }
    }

}